#include "testApp.h"

//--------------------------------------------------------------
void testApp::setup(){

    //load Images
    Image1.loadImage("levitate.png");
    Image2.loadImage("speaker.png");
    Image3.loadImage("big_speaker.png");
    Image4.loadImage("1up.png");
    Image5.loadImage("prozac.png");
    Image6.loadImage("smiley.png");


    modeCounter=1;

	camWidth 		= 400;	// try to grab at this size.
	camHeight 		= 300;

//	vidGrabber.setVerbose(true);
//	vidGrabber.initGrabber(camWidth,camHeight);

	videoInverted 	= new unsigned char[camWidth*camHeight*3];
	videoTexture.allocate(camWidth,camHeight, GL_RGB);

	texScreen.allocate(800,600,GL_RGBA);
	texScreen2.allocate(800,600,GL_RGB);
	texFlow3.allocate(480,480,GL_RGBA);
	texSpeakr.allocate(480,480,GL_RGBA);

	tex2.allocate(480,480,GL_RGBA);
	tex3.allocate(480,480,GL_RGBA);
	tex4.allocate(480,480,GL_RGBA);
	tex5.allocate(480,480,GL_RGBA);

    texFlow3.loadData(Image1.getPixels(),480,480, GL_RGBA);
    texSpeakr.loadData(Image2.getPixels(),480,480, GL_RGBA);

    tex2.loadData(Image3.getPixels(),480,480, GL_RGBA);
    tex3.loadData(Image4.getPixels(),480,480, GL_RGBA);
    tex4.loadData(Image5.getPixels(),480,480, GL_RGBA);
    tex5.loadData(Image6.getPixels(),480,480, GL_RGBA);

    spin	= 12.0;
	spinPct	= 0.0;


	counter = 0;
	hvel=0.35;
	hX=0;
	texwarp=0;
	texdelta=1;

	lerpdepth=0;
	lerpdelta=2;

	//3dstuff
	ofSetVerticalSync(true);
	//glEnable(GL_DEPTH_TEST); //lights look weird if depth test is not enabled
	centerX = ofGetWidth()/2;
	centerY = ofGetHeight()/2;
	centerZ = 0;

	rotX = 0;
	rotY = 0;
	rotZ = 0;
	bSmoothLight = true;

	//reflexions!!
	ofxMaterialSpecular(120, 120, 120); //how much specular light will be reflect by the surface
	ofxMaterialShininess(80); //how concentrated the reflexion will be (between 0 and 128

	//each light will emit white reflexions
	light1.specular(255, 255, 255);
	light2.specular(255, 255, 255);
	light3.specular(255, 255, 255);
	light4.specular(255, 255, 255);

	texScreen.loadScreenData(0,0,640,480);
	texScreen2.loadScreenData(0,0,640,480);

	//soundstuff
	// load in sounds:
	beat.loadSound("sounds/happy_rmx.wav");


	// we will bounce a circle using these variables:
	px = 300;
	py = 300;
	vx = 0;
	vy = 0;

	// the fft needs to be smoothed out, so we create an array of floats
	// for that purpose:
	fftSmoothed = new float[8192];
	for (int i = 0; i < 8192; i++){
		fftSmoothed[i] = 0;
	}

	nBandsToGet = 128;

	w=800;
	h=600;
	//-----------------------------------spawn the particles add to array.
	//you can add more if you want, tried 20k and it still ran fairly smooth
	// but it drew so fast I could not grab screens I liked fast enough
	for(int i=0; i < 20; i++){
		gHairList.push_back(hair_particle() );
	}
	for(int i=0; i < 20; i++){
		gHairList2.push_back(hair_particle() );
	}
	for(int i=0; i < 20; i++){
		gHairList3.push_back(hair_particle() );
	}
	for(int i=0; i < 20; i++){
		gHairList4.push_back(hair_particle() );
	}
	for(int i=0; i < 20; i++){
		gHairList5.push_back(hair_particle() );
	}
}


//--------------------------------------------------------------
void testApp::update(){

    //soundstuff--------------------------------------------
    float * val = ofSoundGetSpectrum(nBandsToGet);		// request 128 values for fft
	for (int i = 0;i < nBandsToGet; i++){

		// let the smoothed calue sink to zero:
		fftSmoothed[i] *= 0.96f;

		// take the max, either the smoothed or the incoming:
		if (fftSmoothed[i] < val[i]) fftSmoothed[i] = val[i];

	}
    //soundstuff--------------------------------------------

    counter += 1;
    hX += hvel;
    if (hX > 600){
        hvel=hvel*-1;
        hX=599;
        }
    if (hX < -200){
        hvel=hvel*-1;
        hX=-199;
        }
    //texture warp
    texwarp+=texdelta;

    if (texwarp > 400){
        texdelta=texdelta*-1;
        texwarp=399;
        }
    if (texwarp < 0){
        texdelta=texdelta*-1;
        texwarp=0;
        }

       // if (lerpdepth < 50 && lerpdepth > -50){modeCounter=0;}

	//ofBackground(100,100,100);

//	vidGrabber.grabFrame();
//
//	if (vidGrabber.isFrameNew()){
//		int totalPixels = camWidth*camHeight*3;
//		unsigned char * pixels = vidGrabber.getPixels();
//		for (int i = 0; i < totalPixels; i++){
//			//videoInverted[i] = 255 - pixels[i];
//			videoInverted[i] = pixels[i];
//		}
//		videoTexture.loadData(videoInverted, camWidth,camHeight, GL_RGB);
//	}



	//reduce the spinPct by a small amount
	//so that the spinning eventually stops
	//this is the same as writing:
	//spinPct = spinPct * 0.99;
	spinPct	*= 0.99f;

	//update the spin -which is storing the
	//total rotation- by spinPct
	spin	+= spinPct;

	// texScreen.loadScreenData(0,0,640,480);

	 //3dstuff
	 rotX += 0.3;
	rotY += 0.3;
	rotZ += 0.3;

	//light1
	float L1DirectionX = 1;
	float L1DirectionY = 0;
	float L1DirectionZ = 0;

	light1.directionalLight(255, 0, 0, L1DirectionX, L1DirectionY, L1DirectionZ);

	//light2
	float L2ConeAngle = 50;
	float L2Concentration = 150;
	float L2PosX = centerX;
	float L2PosY = centerY;
	float L2PosZ = -500;
	float L2DirectionX = 0;
	float L2DirectionY = 0;
	float L2DirectionZ = 01;

	light2.spotLight(255, 0, 0,
					 L2PosX, L2PosY, L2PosZ,
					 L2DirectionX, L2DirectionY, L2DirectionZ,
					 L2ConeAngle,
					 L2Concentration);

	//light3
	float L3PosX = ofGetWidth();
	float L3PosY = mouseY;
	float L3PosZ = 500;
	light3.pointLight(0, 0, 255, L3PosX, L3PosY, L3PosZ);

	 //texScreen.loadScreenData(20,20,620,460);

	 //light4
	 L1DirectionX = 1;
	 L1DirectionY = 0;
	 L1DirectionZ = 0;

	 //dynamic light test
    r=r-2;

    if (r< (fftSmoothed[60] * 1200)){
        r= (fftSmoothed[60] * 1200);
        }

    if (r> 255){
        r= 255;
    }

     g=g-2;

    if (g< (fftSmoothed[10] * 400)){
        g= (fftSmoothed[10] * 400);
        }

    if (g> 255){
        g= 255;
    }

    b=b-5;
    if (b< (fftSmoothed[100] * 1800)){
        b= (fftSmoothed[100] * 1800);
        }

    if (b> 255){
        b= 255;
    }
	light4.directionalLight(128, 255, 0, L1DirectionX, L1DirectionY, L1DirectionZ);
	//light4.directionalLight(r, g, b, L1DirectionX, L1DirectionY, L1DirectionZ);
    camera.lerpPosition(centerX,centerY, lerpdepth, 0.15);

    adelta=adelta-4.50;

    if (adelta< (fftSmoothed[60] * 2200)){
        adelta= (fftSmoothed[60] * 2200);
        }

        adelta2=adelta2-1.50;

    if (adelta2< (fftSmoothed[40] * 2200)){
        adelta2= (fftSmoothed[40] * 2200);
        }

    //if (adelta > 255){adelta=255;}

    adeltabass=adeltabass-3.58;
    if (adeltabass< (fftSmoothed[1] * 225)){
        adeltabass= (fftSmoothed[1] * 225);
        }
     if (adeltabass > 255){adeltabass=255;}
     //lerpdepth
     //lerpdepth+=lerpdelta;
   lerpdepth= 80+adeltabass;
//    if (lerpdepth > 500){
//        lerpdelta=lerpdelta*-1;
//        lerpdepth=499;
//        }
//    if (lerpdepth < -500){
//        lerpdelta=lerpdelta*-1;
//        lerpdepth=-499;
//        }

    adelta_treb=adelta_treb-4.58;
    if (adelta_treb< (fftSmoothed[1] * 3250)){
        adelta_treb= (fftSmoothed[1] * 3250);
        }
    // if (adelta_treb > 255){adelta_treb=255;}

        	//loop through objects and update or reassign them
    int tempctr=0;
	for(int i=0; i < gHairList.size(); i++){
		//if a particle is active
		if (gHairList[i].active()){
			//update the particle
			gHairList[i].update_frame();
		}
		//if a particle is NOT active lets recycle it
		if (!gHairList[i].active() && (fftSmoothed[60] * 2200 > 25) ){
			//pick an arbitrary value in the array of values
            tempctr=tempctr=1;
			aval=300;
            if (tempctr < 10){
			//initialize the particle
			gHairList[i].draw_me( aval, tempctr*3, ofRandom(1,w), ofRandom(1,h));
            }

		}
	}

	tempctr=0;
	for(int i=0; i < gHairList2.size(); i++){
		//if a particle is active
		if (gHairList2[i].active()){
			//update the particle
			gHairList2[i].update_frame();
		}
		//if a particle is NOT active lets recycle it
		if (!gHairList2[i].active() && (fftSmoothed[60] * 2200 < 5) ){
			//pick an arbitrary value in the array of values
            tempctr=tempctr=1;
			aval=300;
            if (tempctr < 10){
			//initialize the particle
			gHairList2[i].draw_me( aval, tempctr*3, ofRandom(1,w), ofRandom(1,h));
            }

		}
	}

	tempctr=0;
	for(int i=0; i < gHairList3.size(); i++){
		//if a particle is active
		if (gHairList3[i].active()){
			//update the particle
			gHairList3[i].update_frame();
		}
		//if a particle is NOT active lets recycle it
		if (!gHairList3[i].active() && (fftSmoothed[10] * 1200 > 55) ){
			//pick an arbitrary value in the array of values
            tempctr=tempctr=1;
			aval=300;
            if (tempctr < 10){
			//initialize the particle
			gHairList3[i].draw_me( aval, tempctr*3, ofRandom(1,w), ofRandom(1,h));
            }

		}
	}

	tempctr=0;
	for(int i=0; i < gHairList4.size(); i++){
		//if a particle is active
		if (gHairList4[i].active()){
			//update the particle
			gHairList4[i].update_frame();
		}
		//if a particle is NOT active lets recycle it
		if (!gHairList4[i].active() && (fftSmoothed[60] * 2200 < 5) ){
			//pick an arbitrary value in the array of values
            tempctr=tempctr=1;
			aval=300;
            if (tempctr < 10){
			//initialize the particle
			gHairList4[i].draw_me( aval, tempctr*3, ofRandom(1,w), ofRandom(1,h));
            }

		}
	}
    //-----------------------------------------------------high treble particles
	tempctr=0;
	for(int i=0; i < gHairList5.size(); i++){
		//if a particle is active
		if (gHairList5[i].active()){
			//update the particle
			gHairList5[i].update_frame();
		}
		//if a particle is NOT active lets recycle it
		if (!gHairList5[i].active() && (fftSmoothed[120] * 100 > 1) ){
			//pick an arbitrary value in the array of values
            tempctr=tempctr=1;
			aval=300;
            if (tempctr < 10){
			//initialize the particle
			gHairList5[i].draw_me( aval, tempctr*3, ofRandom(1,w), ofRandom(1,h));
            }

		}
	}
}

//--------------------------------------------------------------
void testApp::draw(){
ofxLightsOn(); //turn lights on

ofEnableAlphaBlending();
	//glBlendFunc(GL_SRC_COLOR, GL_ONE);

   if (counter > 1) {
     ofSetColor(255,255,255,255);
    texScreen.draw(0,0,camWidth,camHeight);
    texScreen.draw(0+(camWidth*2),0,-camWidth,camHeight);
	texScreen.draw(0+(camWidth*2),0+(camHeight*2),-camWidth,-camHeight);
	texScreen.draw(0,0+(camHeight*2),camWidth,-camHeight);
   }


//3dstuff
    camera.place();//this MUST be inside the draw function, and actually places the camera in position


	ofSetColor(255, 255, 255,180);

	//ofxSphere(centerX - 150, centerY - 150, 0, 50, 100, 100, rotX, rotY, 0);

	//ofxBox(centerX + 150, centerY - 150, 0, 100, 200, 20, rotX, rotY, 0);

	 for (int i = -250; i < 250; i+=20){
			//videoInverted[i] = 255 - pixels[i];
			 ofSetColor(255, abs(i), 255,140);
			ofxBox(centerX+i, centerY+i , 0, 600-abs(i)*2+adelta, 30+adelta, 4+adelta, -rotX, rotY, -rotZ);

			//ofxBox(hX + i, centerY , 0, 80, 580-abs(i)*2, 4, rotX, rotY, -rotX);
    //(fftSmoothed[i] * 200)

			//ofxSphere(centerX + i, centerY - 150, 0, 50, 50, 50, rotX, rotY, 0);
    }


	for (int i = -250; i < 250; i+=80){
	    for (int j = -250; j < 250; j+=80){
			//videoInverted[i] = 255 - pixels[i];
			ofSetColor(abs(i), abs(i), 255,200);
			ofxSphere(centerX+j , centerY+i , 0, 10+adelta/6, 60+adelta/6, abs(i)/2+adelta/4, rotX, rotY, -rotX);



			}
    }

int temp=adelta2; //create a gvernor for number of lines
if (temp > 300){
    temp=300;
    }

    for (int i = -adelta2; i < adelta2; i+=40){
			//videoInverted[i] = 255 - pixels[i];

			ofSetColor(255, abs(i), abs(i), 250);

			ofxBox(centerX + i, centerY , 0, 60+adelta, 600-abs(i)*2+adelta, 4+adelta, rotX, rotY, rotZ);

			ofxBox(hX + i, centerY , 0+adelta_treb, 80+adelta, 580-abs(i)*2+adelta, 4+adelta, rotX, rotY, -rotZ);


			//ofxSphere(centerX + i, centerY - 150, 0, 50, 50, 50, rotX, rotY, 0);
    }
//-------------------------------------------------------------------lines 1
ofNoFill();  //--circle outlines
temp=adelta2; //create a gvernor for number of lines
if (temp > 300){
    temp=300;
    }
for (int i = 0; i < temp; i+=10){
			//videoInverted[i] = 255 - pixels[i];

			ofSetColor(255, 0, 0, i);
			//ofSetLineWidth(2+adelta_treb);
            //ofLine(centerX + i,centerY,hX + i, 0+adelta_treb);

            ofCircle(centerX,centerY,10+i);

			//ofxBox(centerX + i, centerY , 0, 60+adelta, 600-abs(i)*2+adelta, 4+adelta, rotX, rotY, rotX);

			//ofxBox(hX + i, centerY , 0+adelta_treb, 80+adelta, 580-abs(i)*2+adelta, 4+adelta, rotX, rotY, -rotX);


			//ofxSphere(centerX + i, centerY - 150, 0, 50, 50, 50, rotX, rotY, 0);
    }
      ofFill();  //reset fill

//-----------------------------------------------------------
temp=adelta; //create a gvernor for number of lines
if (temp > 300){
    temp=300;
    }
int temp2=adelta_treb; //create a gvernor for number of lines
if (temp2 > 300){
    temp2=300;
    }


      for (int i = -temp; i < temp; i+=100){
	    for (int j = -temp2; j < temp2; j+=100){
			//videoInverted[i] = 255 - pixels[i];
			ofSetColor(abs(i), abs(i), 255,200);
			ofxSphere(centerX+j , centerY+i , 0+adelta_treb/8, 10+adelta/8, 30+adelta/8, abs(i)/(4+adelta), rotX, rotY, -rotZ);



			}
    }

   // glBindTexture(GL_TEXTURE_2D, texScreen.getTextureReference());

   //texScreen.bind();
     for (int i = -temp2; i < temp2; i+=180){
	    for (int j = -temp; j < temp; j+=180){
			//videoInverted[i] = 255 - pixels[i];
			 ofSetColor(255, abs(i), 255,255);
			 ofxBox(centerX +i , centerY+j , i+adelta, abs(i)/2, abs(i)/2, abs(i)/2+adelta, rotX, rotY, -rotX);
			 ofxBox(centerX +i , centerY+j , i+adelta, abs(i), abs(i)/3, abs(i)/3+adelta, rotX, rotY, -rotX);
			 ofxBox(centerX +i , centerY+j , i+adelta, abs(i)*2, abs(i)/4, abs(i)/4+adelta, rotX, rotY, -rotX);



			}
    }
    //texScreen.unbind();
     ofSetColor(255,255,255);

//    texSpeakr.bind();
//    //texFlow3.bind();
//    draw_tile(10*adelta,20*adelta,10*adelta, centerX ,centerY, centerZ, rotX, rotY, rotZ);
//    texSpeakr.unbind();
//
     ofxLightsOff(); //turn lights off to draw text


   //----------------------------------------------------------particle 2
glPushMatrix();
for(int i=0; i < gHairList2.size(); i++){
		//if a particle is active
		if (gHairList2[i].active()){

			float anx=gHairList2[i].get_myX();
			float ay=gHairList2[i].get_myY();
			int avalue=gHairList2[i].get_value();
			float ablend=gHairList2[i].get_blend();
			float ascale=gHairList2[i].get_scale();
            avalue=avalue/2;
			//Draw Rou/2;ine here
            ofRotate(-rotZ/70,0.0,rotZ,rotZ);
			tex4.draw(anx,ay,ascale,ascale);

		}
	}
   glPopMatrix();

    //----------------------------------------------------------particle 3

    glPushMatrix();
    for(int i=0; i < gHairList3.size(); i++){
		//if a particle is active
		if (gHairList3[i].active()){

			float anx=gHairList3[i].get_myX();
			float ay=gHairList3[i].get_myY();
			int avalue=gHairList3[i].get_value();
			float ablend=gHairList3[i].get_blend();
			float ascale=gHairList3[i].get_scale();
            avalue=avalue/2;
			//Draw Rou/2;ine here
            ofRotate(-rotX/120,0.0,rotZ,rotZ);
			tex3.draw(anx,ay,ascale,ascale);

		}
	}
   glPopMatrix();

   //----------------------------------------------------------particle 4

    glPushMatrix();
    for(int i=0; i < gHairList4.size(); i++){
		//if a particle is active
		if (gHairList4[i].active()){

			float anx=gHairList4[i].get_myX();
			float ay=gHairList4[i].get_myY();
			int avalue=gHairList4[i].get_value();
			float ablend=gHairList4[i].get_blend();
			float ascale=gHairList4[i].get_scale();
            avalue=avalue/2;
			//Draw Rou/2;ine here
            ofRotate(rotZ/120,0.0,rotZ,rotZ);
			tex2.draw(anx,ay,ascale,ascale);

		}
	}
   glPopMatrix();


   //----------------------------------------------------------particle 1
glPushMatrix();
for(int i=0; i < gHairList.size(); i++){
		//if a particle is active
		if (gHairList[i].active()){
			//draw particle to fbo---------------------------------<<<<draw here
			//gHairList[i].update_frame();

			float anx=gHairList[i].get_myX();
			float ay=gHairList[i].get_myY();
			int avalue=gHairList[i].get_value();
			float ablend=gHairList[i].get_blend();
			float ascale=gHairList[i].get_scale();
            avalue=avalue/2;
			//Draw Rou/2;ine here
//			ofSetColor(r,g,b,ablend); //set color and alpha blend
//
//			//ofEnableAlphaBlending(); //enable alpha blending
//			ofCircle(anx,ay, ascale); //draw a circle
//			//inside circle
//			float ascale3=ascale/3;
//			ofCircle(anx,ay, ascale3);
//			float ascale4=ascale/4;
//			ofCircle(anx,ay, ascale4);
            ofRotate(rotZ/100,0.0,rotZ,rotZ);
			texFlow3.draw(anx,ay,ascale,ascale);
             //ofxBox(anx , ay , ascale, avalue, avalue,avalue, -rotX, rotY, -rotX);
			//ofDisableAlphaBlending(); //disable alpha blending

		}

	}
   glPopMatrix();


   //----------------------------------------------------------particle 5

    glPushMatrix();
    for(int i=0; i < gHairList5.size(); i++){
		//if a particle is active
		if (gHairList5[i].active()){

			float anx=gHairList5[i].get_myX();
			float ay=gHairList5[i].get_myY();
			int avalue=gHairList5[i].get_value();
			float ablend=gHairList5[i].get_blend();
			float ascale=gHairList5[i].get_scale();
            avalue=avalue/2;
			//Draw Rou/2;ine here
            ofRotate(rotZ/120,0.0,rotZ,rotZ);
			tex5.draw(anx,ay,ascale,ascale);

		}
	}
   glPopMatrix();

//--------------------------------------------------------------------end particles

glPushMatrix();
 float afft1 =fftSmoothed[12]*2600;
    ofRotate(rotZ,0.0,rotZ,rotZ);
    texFlow3.draw(0 -(afft1/2),0-(afft1/2),afft1,afft1);
    ofRotate(rotZ +90,0.0,rotZ,rotZ);
    texFlow3.draw(0 -(afft1/2),0-(afft1/2),afft1,afft1);
    ofRotate(rotZ +180,0.0,rotZ,rotZ);
    texFlow3.draw(0 -(afft1/2),0-(afft1/2),afft1,afft1);
    ofRotate(rotZ +270,0.0,rotZ,rotZ);
    texFlow3.draw(0 -(afft1/2),0-(afft1/2),afft1,afft1);
 glPopMatrix();

    //texFlow3.draw(anx,ay,ascale,ascale);

    texScreen.loadScreenData(0+texwarp,0+texwarp,640-texwarp,480-texwarp);

   // ofxLightsOff(); //turn lights off to draw text

//-------------------------------------------------------------------------------
 if (modeCounter > 1){
    if (counter > 1) {
    ofSetColor(255,255,255);
    texScreen.draw(0,0,camWidth,camHeight);
    texScreen.draw(0+(camWidth*2),0,-camWidth,camHeight);
	texScreen.draw(0+(camWidth*2),0+(camHeight*2),-camWidth,-camHeight);
	texScreen.draw(0,0+(camHeight*2),camWidth,-camHeight);
   }


//-------------------------------------------------------------------------------

   texScreen.loadScreenData(0+texwarp,0+texwarp,640-texwarp,480-texwarp);

 }
 //-------------------------------------------------------------------------------
 if (modeCounter > 2){
   if (counter > 1) {
    ofSetColor(255,255,235);
    texScreen.draw(0,0,camWidth,camHeight);
    texScreen.draw(0+(camWidth*2),0,-camWidth,camHeight);
	texScreen.draw(0+(camWidth*2),0+(camHeight*2),-camWidth,-camHeight);
	texScreen.draw(0,0+(camHeight*2),camWidth,-camHeight);
   }

 texScreen2.loadScreenData(0,0,480,480);

texScreen.loadScreenData(0+texwarp,0+texwarp,640-texwarp,480-texwarp);

 glPushMatrix();
 float afft =fftSmoothed[16]*2600;
    texFlow3.draw(400 -(afft/2),300-(afft/2),afft,afft);
 glPopMatrix();

 }
//-------------------------------------------------------------------------------
 if (modeCounter > 3){
   if (counter > 1) {
    ofSetColor(255,255,235);
    texScreen.draw(0,0,camWidth,camHeight);
    texScreen.draw(0+(camWidth*2),0,-camWidth,camHeight);
	texScreen.draw(0+(camWidth*2),0+(camHeight*2),-camWidth,-camHeight);
	texScreen.draw(0,0+(camHeight*2),camWidth,-camHeight);
   }
 }
//-------------------------------------------------------------------------------
 //texFlow3.draw(400,300,fftSmoothed[60]*2600,fftSmoothed[60]*2600);
    ofDisableAlphaBlending();

}


//--------------------------------------------------------------
void testApp::keyPressed  (int key){

	// in fullscreen mode, on a pc at least, the
	// first time video settings the come up
	// they come up *under* the fullscreen window
	// use alt-tab to navigate to the settings
	// window. we are working on a fix for this...

//	if (key == 's' || key == 'S'){
//		vidGrabber.videoSettings();
//	}

	if (key == 'm' || key == 'M'){
		modeCounter= modeCounter+1;
        if (modeCounter > 4){ modeCounter=1;}
	}

	if (key == '1' ){
		texFlow3.loadData(Image1.getPixels(),480,480, GL_RGBA);
	}
	if (key == '2' ){
		texFlow3.loadData(Image2.getPixels(),480,480, GL_RGBA);
	}
	if (key == '3' ){
		texFlow3.loadData(Image3.getPixels(),480,480, GL_RGBA);
	}
	if (key == '4' ){
		texFlow3.loadData(Image4.getPixels(),480,480, GL_RGBA);
	}
	if (key == '5' ){
		texFlow3.loadData(Image5.getPixels(),480,480, GL_RGBA);
	}
	if (key == '6' ){
		texFlow3.loadData(Image6.getPixels(),480,480, GL_RGBA);
	}


}


//--------------------------------------------------------------
void testApp::keyReleased(int key){

}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){

}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){

     beat.play();
}

//--------------------------------------------------------------
void testApp::mouseReleased(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::resized(int w, int h){

}
void testApp::draw_plane(float aw, float ah, float ad, float ax,float ay, float az, float arot, float atw, float ath){
    glPushMatrix();

	//glTranslatef(ax,ay,az);
	glTranslatef(ax,ay,az);

	//glRotatef(rotX,1.0f,0.0f,0.0f);
	glRotatef(arot,0.0f,1.0f,0.0f);
	//glRotatef(rotZ,0.0f,0.0f,1.0f);

	//glBindTexture(GL_TEXTURE_2D, texture[0]);
	//ofSetColor(255,255,255);
	//texScreen2.bind();

  // ofxLightsOff();

    float w=aw;
    float h =ah;
    float scale= ad;

    float tw=atw;
    float th=ath;

	glBegin(GL_QUADS);


    //  Face
		glTexCoord2f(1.0f*tw, 0.0f); glVertex3f(1.0f*w, -1.0f*h, -1.0f*scale);
		glTexCoord2f(1.0f*tw, 1.0f*th); glVertex3f(1.0f*w,  1.0f*h, -1.0f*scale);
		glTexCoord2f(0.0f, 1.0f*th); glVertex3f( -1.0f*w,  1.0f*h, -1.0f*scale);
		glTexCoord2f(0.0f, 0.0f); glVertex3f( -1.0f*w, -1.0f*h, -1.0f*scale);

	glEnd();

 glPopMatrix();
}
void testApp::draw_tile(float aw, float ah, float ad, float ax,float ay, float az, float arot,float atw, float ath){
    glPushMatrix();

	//glTranslatef(ax,ay,az);
	glTranslatef(ax,ay,az);

	//glRotatef(rotX,1.0f,0.0f,0.0f);
	glRotatef(arot,0.0f,1.0f,0.0f);
	//glRotatef(rotZ,0.0f,0.0f,1.0f);

	//glBindTexture(GL_TEXTURE_2D, texture[0]);
	//ofSetColor(255,255,255);
	//texScreen2.bind();

   //ofxLightsOff();

    float w=aw;
    float h =ah;
    float scale=ad;
    float tw=atw;
    float th=ath;

	glBegin(GL_QUADS);

	// Front Face
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f*w, -1.0f*h,  1.0f*scale);
		glTexCoord2f(1.0f*tw, 0.0f); glVertex3f( 1.0f*w, -1.0f*h,  1.0f*scale);
		glTexCoord2f(1.0f*tw, 1.0f*th); glVertex3f( 1.0f*w,  1.0f*h,  1.0f*scale);
		glTexCoord2f(0.0f, 1.0f*th); glVertex3f(-1.0f*w,  1.0f*h,  1.0f*scale);
		// Back Face
		glTexCoord2f(1.0f*tw, 0.0f); glVertex3f(-1.0f*w, -1.0f*h, -1.0f*scale);
		glTexCoord2f(1.0f*tw, 1.0f*th); glVertex3f(-1.0f*w,  1.0f*h,-1.0f*scale);
		glTexCoord2f(0.0f, 1.0f*th); glVertex3f( 1.0f*w,  1.0f*h, -1.0f*scale);
		glTexCoord2f(0.0f, 0.0f); glVertex3f( 1.0f*w, -1.0f*h, -1.0f*scale);
		// Top Face
		 glVertex3f(-1.0f*w,  1.0f*h, -1.0f*scale);
		glVertex3f(-1.0f*w,  1.0f*h,  1.0f*scale);
		 glVertex3f( 1.0f*w,  1.0f*h,  1.0f*scale);
		 glVertex3f( 1.0f*w,  1.0f*h, -1.0f*scale);
		// Bottom Face
		glVertex3f(-1.0f*w, -1.0f*h, -1.0f*scale);
		glVertex3f( 1.0f*w,-1.0f*h, -1.0f*scale);
		glVertex3f( 1.0f*w, -1.0f*h,  1.0f*scale);
        glVertex3f(-1.0f*w, -1.0f*h,  1.0f*scale);
		// Right face
		glVertex3f( 1.0f*w, -1.0f*h, -1.0f*scale);
		glVertex3f( 1.0f*w,  1.0f*h, -1.0f*scale);
		glVertex3f( 1.0f*w,  1.0f*h,  1.0f*scale);
		glVertex3f( 1.0f*w, -1.0f*h,  1.0f*scale);
		// Left Face
		glVertex3f(-1.0f*w, -1.0f*h, -1.0f*scale);
		glVertex3f(-1.0f*w, -1.0f*h,  1.0f*scale);
		glVertex3f(-1.0f*w,  1.0f*h,  1.0f*scale);
		glVertex3f(-1.0f*w,  1.0f*h, -1.0f*scale);
	glEnd();
	 //ofxLightsOff();
 glPopMatrix();
}
